chiark / gitweb /
el/dot-emacs.el: Bug fix to last-one-out.
[profile] / setup
... / ...
CommitLineData
1#! /bin/bash
2
3set -e
4
5###--------------------------------------------------------------------------
6### Basic setup.
7
8umask 002
9
10sub=
11mkdir -p $HOME$sub
12
13: ${REPO=http://ftp.distorted.org.uk/ftp/pub/mdw/profile}
14
15export PATH=/usr/local/bin:$HOME$sub/bin:/usr/bin:/usr/ccs/bin:/bin
16
17###--------------------------------------------------------------------------
18### Sort out command line.
19
20xstuff= false=
21while [ $# -gt 0 ]; do
22 case "$1" in
23 -x) xstuff=t;;
24 -n) false=false;;
25 --) shift; break;;
26 -*) echo >&2 "$0: bad option"; exit 1;;
27 *) break;;
28 esac
29 shift
30done
31
32###--------------------------------------------------------------------------
33### Environment autoconfiguration.
34
35## Find out where I am
36here=$(pwd)
37
38## Suss out how to print things
39out=$(echo -n "foo"; echo "bar")
40if [ "$out" = "foobar" ]; then
41 echon="echo -n"
42 echoc=""
43else
44 echon="echo"
45 echoc='\c'
46fi
47
48## Find out how to fetch things over the net
49$echon "Finding URL fetcher:$echoc"
50if curl >/dev/null 2>&1 --version || [ $? -eq 2 ]; then
51 GETURL="curl -fs -o"
52 echo " curl."
53elif wget >/dev/null 2>&1 --version; then
54 GETURL="wget -q -O"
55 echo " wget."
56else
57 echo " failed!"
58 echo >&2 "$0: failed to find URL fetcher"
59 exit 1
60fi
61
62###--------------------------------------------------------------------------
63### Create the necessary directories.
64
65echo "Creating directories..."
66for i in bin lib/emacs src; do
67 $echon " $i:$echoc"
68 if [ -d $HOME$sub/$i ]; then
69 echo " already exists."
70 else
71 mkdir -p $HOME$sub/$i
72 echo " done."
73 fi
74done
75echo " all done."
76
77###--------------------------------------------------------------------------
78### Install some more complicated programs.
79
80echo "Installing packages..."
81systems="
82 mlib:crc-mktab
83 checkpath:tmpdir
84"
85[ "$xstuff" ] && systems="$systems
86 xtoys:xatom
87"
88for system in $systems; do
89 set -- $(echo $system | tr : ' ')
90 sys=$1 prog=$2
91 $echon " $sys:$echoc"
92 if $false $prog >/dev/null 2>&1 --version; then
93 echo " already installed."
94 else
95 ( set -e
96 $echon " downloading$echoc"
97 cd $HOME$sub/src
98 rm -rf $sys.tar.gz $sys-$ver
99 $GETURL $sys.tar.gz $REPO/$sys.tar.gz
100 $echon " unpacking$echoc"
101 dir=$(gzip -cd $sys.tar.gz | tar tf - | head -1)
102 gzip -cd $sys.tar.gz | tar xf -
103 $echon " configuring$echoc"
104 cd $dir
105 mkdir build
106 cd build
107 ../configure --prefix=$HOME$sub >>buildlog 2>&1
108 $echon " building$echoc"
109 make >>buildlog 2>&1
110 $echon " installing$echoc"
111 make install >>buildlog 2>&1
112 echo " done."
113 )
114 fi
115done
116echo " all done."
117
118###--------------------------------------------------------------------------
119### Install global configuration.
120
121echo -n "Installing dotfile configuration:"
122if [ -f $HOME$sub/.mdw.conf ]; then
123 echo " already installed."
124else
125 cp mdw.conf $HOME$sub/.mdw.conf
126 echo " done."
127fi
128
129## Symlink the various dotfiles into place
130dotfiles="
131 bash_profile bash_logout bashrc inputrc bash_completion
132 emacs emacs-calc vm gnus.el
133 vimrc mg zile
134 mailrc signature
135 cgrc tigrc
136 gdbinit
137 guile
138 toprc
139 aspell.conf
140 lisp-init.lisp:.cmucl-init.lisp
141 lisp-init.lisp:.sbclrc
142 lisp-init.lisp:.clisprc.lisp
143 lisp-init.lisp:.eclrc
144 swank.lisp
145 dircolors colordiffrc screenrc cvsrc indent.pro"
146[ "$xstuff" ] && dotfiles="$dotfiles
147 xinitrc xsession Xdefaults vncrc vncsession
148 fonts.conf
149 stalonetrayrc
150 putty-defaults:.putty/sessions/Default%20Settings
151 eterm-theme.cfg:.Eterm/themes/Eterm/theme.cfg
152 e-keybindings.cfg:.enlightenment/keybindings.cfg
153 evnc-keybindings.cfg:.enlightenment-vnc/keybindings.cfg
154 e16-bindings:.e16/bindings.cfg"
155echo "Installing dotfiles..."
156for d in $dotfiles; do
157 target=.$d
158 case $d in
159 *:*) target=${d#*:} d=${d%%:*};;
160 esac
161 ft=$HOME$sub/$target
162 dir=${ft%/*}
163 mkdir -p $dir
164 ln -s $here/dot/$d $ft.new
165 mv $ft.new $ft
166 echo " $target"
167done
168echo " all done."
169
170## Symlink backgrounds.
171backgrounds="
172 jue-peek.jpg
173 medusa.jpg
174 bsg-supper.jpg
175 rayne.jpg
176 hypatia.jpg
177 noodly.jpg"
178if [ "$xstuff" ]; then
179 echo "Installing backgrounds..."
180 for b in $backgrounds; do
181 for e in enlightenment e16; do
182 dir=$HOME$sub/.$e/backgrounds
183 t=$dir/$b
184 mkdir -p $dir
185 ln -s $here/bg/$b $t.new
186 mv $t.new $t
187 done
188 echo " $b"
189 done
190 echo " all done."
191fi
192
193###--------------------------------------------------------------------------
194### Process the Git configuration.
195
196echo -n "Installing Git configuration:"
197sed "
1981i\
199### generated by $here/setup; do not edit!\
200
201/@releasekey@/ s::$(bin/mdw-conf release-key 481334C2):g
202/@gitignore@/ s::$(bin/mdw-conf gitignore $here/git/gitignore):g
203" git/gitconfig >$HOME/.gitconfig.new
204mv $HOME/.gitconfig.new $HOME/.gitconfig
205echo " done."
206
207###--------------------------------------------------------------------------
208### Install useful scripts included in this package.
209
210scripts="
211 mdw-editor
212 mdw-pager
213 mdw-conf
214 mdw-build
215 movemail-hack
216 emerge-hack
217 lesspipe.sh
218 start-ssh-agent
219 svnwrap
220 hyperspec"
221[ "$xstuff" ] && scripts="$scripts
222 xinitcmd
223 un-backslashify-selection
224 lock-screen
225 xshutdown"
226echo "Installing scripts..."
227mkdir -p $HOME$sub/bin
228for s in $scripts; do
229 ft=$HOME$sub/bin/$s
230 ln -s $here/bin/$s $ft.new
231 mv $ft.new $ft
232 echo " $s"
233done
234echo " all done."
235
236###--------------------------------------------------------------------------
237### Set up the Emacs config.
238
239$echon "Finding a suitable emacs:$echoc"
240emacs=no
241for i in emacs22 emacs21 emacs; do
242 if type -p >/dev/null $i; then
243 emacs=$i
244 break
245 fi
246done
247if [ $emacs = no ]; then
248 echo " failed."
249 emacs=:
250else
251 echo " $emacs."
252fi
253
254echo "Installing Emacs packages..."
255emacspkg="
256 make-regexp
257 ew-hols
258 mdw-gnus-patch
259 git git-blame vc-git stgit
260 quilt"
261for elib in $emacspkg; do
262 $echon " $elib:$echoc"
263 if $false $emacs >/dev/null 2>&1 --no-site-file --batch --eval '
264 (progn
265 (setq load-path (nconc load-path (list "~/lib/emacs")))
266 (kill-emacs (condition-case nil
267 (progn (load-library "'"$elib"'") 0)
268 (error 1))))'; then
269 echo " already installed."
270 else
271 if [ -f el/$elib.el ]; then
272 cp el/$elib.el $HOME$sub/lib/emacs/$elib.el
273 else
274 $echon " downloading$echoc"
275 $GETURL $HOME$sub/lib/emacs/$elib.el $REPO/$elib.el
276 fi
277 $echon " compiling$echoc"
278 (cd $HOME$sub/lib/emacs;
279 $emacs >/dev/null 2>&1 --no-site-file --batch \
280 --eval '(byte-compile-file "'"$elib.el"'")')
281 echo " done."
282 fi
283done
284echo " all done."
285
286$echon "Setting up Emacs configuration:$echoc"
287$echon " linking$echoc"
288for f in dot-emacs.el Makefile; do
289 set -- $(echo $link | tr : ' ')
290 ln -s $here/el/$f $HOME$sub/lib/emacs/$f.new
291 mv $HOME$sub/lib/emacs/$f.new $HOME$sub/lib/emacs/$f
292done
293$echon " compiling$echoc"
294make >/dev/null 2>&1 -C $HOME$sub/lib/emacs EMACS=$emacs
295echo " done."
296
297###----- That's all, folks --------------------------------------------------